Package org.apache.commons.io.input

# Class ReadAheadInputStream.Builder

java.lang.Object
org.apache.commons.io.build.AbstractSupplier<T,B>
org.apache.commons.io.build.AbstractOriginSupplier<T,B>
org.apache.commons.io.build.AbstractStreamBuilder<ReadAheadInputStream,ReadAheadInputStream.Builder>
org.apache.commons.io.input.ReadAheadInputStream.Builder

All Implemented Interfaces:
  `IOSupplier<ReadAheadInputStream>`

Enclosing class:
  ReadAheadInputStream

public static class ReadAheadInputStream.Builder extends AbstractStreamBuilder<ReadAheadInputStream,ReadAheadInputStream.Builder>
Builds a new `ReadAheadInputStream`.

For example:

     ReadAheadInputStream s = ReadAheadInputStream.builder()
       .setPath(path)
       .setExecutorService(Executors.newSingleThreadExecutor(ReadAheadInputStream::newThread))
       .get();

Since:
  2.12.0
See Also:
  - `get()`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Builder()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ReadAheadInputStream`
  `get()`
  Builds a new `ReadAheadInputStream`.
  `ReadAheadInputStream.Builder`
  `setExecutorService(ExecutorService executorService)`
  Sets the executor service for the read-ahead thread.

  ### Methods inherited from class org.apache.commons.io.build.AbstractStreamBuilder

  `getBufferSize, getBufferSizeDefault, getCharSequence, getCharset, getCharsetDefault, getInputStream, getOpenOptions, getOutputStream, getPath, getReader, getWriter, setBufferSize, setBufferSize, setBufferSizeChecker, setBufferSizeDefault, setBufferSizeMax, setCharset, setCharset, setCharsetDefault, setOpenOptions`

  ### Methods inherited from class org.apache.commons.io.build.AbstractOriginSupplier

  `checkOrigin, getOrigin, hasOrigin, newByteArrayOrigin, newCharSequenceOrigin, newFileOrigin, newFileOrigin, newInputStreamOrigin, newOutputStreamOrigin, newPathOrigin, newPathOrigin, newReaderOrigin, newURIOrigin, newWriterOrigin, setByteArray, setCharSequence, setFile, setFile, setInputStream, setOrigin, setOutputStream, setPath, setPath, setReader, setURI, setWriter`

  ### Methods inherited from class org.apache.commons.io.build.AbstractSupplier

  `asThis`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.io.function.IOSupplier

  `asSupplier`

- ## Constructor Details

  - ### Builder

    public Builder()

- ## Method Details

  - ### get

    public ReadAheadInputStream get() throws IOException
    Builds a new `ReadAheadInputStream`.

    You must set input that supports `AbstractStreamBuilder.getInputStream()`, otherwise, this method throws an exception.

    This builder use the following aspects:

    - `AbstractStreamBuilder.getInputStream()`
    - `AbstractStreamBuilder.getBufferSize()`
    - `ExecutorService`
    Returns:
      a new instance.
    Throws:
      `IllegalStateException` - if the `origin` is `null`.
      `UnsupportedOperationException` - if the origin cannot be converted to an `InputStream`.
      `IOException` - if an I/O error occurs.
    See Also:
      - `AbstractStreamBuilder.getInputStream()`
      - `AbstractStreamBuilder.getBufferSize()`

  - ### setExecutorService

    public ReadAheadInputStream.Builder setExecutorService(ExecutorService executorService)
    Sets the executor service for the read-ahead thread.
    Parameters:
      `executorService` - the executor service for the read-ahead thread.
    Returns:
      this